#Importation des bibliothèques -------------------------------------------------
from tkinter import Tk, Canvas, Button, Text, Label
from PIL import Image, ImageTk
from random import randint
from winsound import PlaySound, SND_ASYNC
import pygame as pg
pg.mixer.init()

#Fonctions ---------------------------------------------------------------------

def creer_fenetre(): #Crée la fenetre principale du jeu                                                                   
    fenetre = Tk()
    fenetre.title("MoleKiller")                                                             
    return fenetre

def widgets(): #Crée la zone de jeu et les boutons                                                                             
    zone = Canvas(fenetre, width=800, height=800, bg="white")                               
    zone.grid(row = 0, column = 0, columnspan = 4)
    
    bouton_facile = Button(fenetre, text = "Niveau facile", width = 25, height=3, state = 'disabled',command = lambda : start(0))   
    bouton_facile.grid(row = 1, column = 1)
    bouton_moyen = Button(fenetre, text = "Niveau moyen", width = 25, height=3, state = 'disabled', command = lambda : start(1))   
    bouton_moyen.grid(row = 1, column = 2)
    bouton_difficile = Button(fenetre, text = "Niveau difficile", width = 25, height=3, state = 'disabled', command = lambda : start(2))   
    bouton_difficile.grid(row = 1, column = 3)

    bouton_classement = Button(fenetre, text = "Afficher le classement", width = 25, height = 3, state = 'disabled', command = affichage_classement)
    bouton_classement.grid(row = 1, column = 0)
    
    text_pseudo = Label(fenetre,text = "Entre ton pseudo : ")
    text_pseudo.grid(row = 2, column = 0)
    zone_pseudo = Text(fenetre, height = 1, width = 50)
    zone_pseudo.grid(row = 2, column = 1, columnspan = 2)
    bouton_valider = Button(fenetre, text = "Valider", width = 25, height = 1, state ='normal', command = unlock)
    bouton_valider.grid(row = 2, column = 3)
    
    return zone, bouton_facile, bouton_moyen, bouton_difficile, bouton_classement, text_pseudo, zone_pseudo, bouton_valider
    
def unlock(): #fonction qui récupère le pseudo du joueur et de déverrouiller l'accès aux boutons des niveaux 
    global pseudo
    pseudo = zone_pseudo.get("1.0", "end-1c")
    if pseudo != "" :
        bouton_classement['state'] = 'disabled'
        bouton_classement['text'] = "Afficher le classement"
        bouton_facile['state']= 'normal'
        bouton_moyen['state']= 'normal'
        bouton_difficile['state']= 'normal'
        bouton_valider['state']= 'disabled'

def start(diff): #Fonction qui lance le jeu
    global v_max, v_min, marteau, aff_cla, aff_niv, aff_pseudo, nom_diff
    if diff == 0 :
        v_min = 600
        v_max = 1000
    elif diff == 1 :
        v_min = 400
        v_max = 800
    elif diff == 2 :
        v_min = 200
        v_max = 600
    zone.delete(img_big_mole)
    zone.delete(aff_fin)
    fenetre.config(cursor = "tcross")
    bouton_facile['state'] = 'disabled'
    bouton_moyen['state'] = 'disabled'
    bouton_difficile['state'] = 'disabled'
    bouton_classement['state'] = 'normal'
    affichage_score()
    animation()
    chronometre()
    difficulty()
    if nom_diff == "facile":
        pg.mixer.music.load("musique_facile.mp3")
    elif nom_diff == "moyen" :
        pg.mixer.music.load("musique_moyen.mp3")
    elif nom_diff == "difficile" :
        pg.mixer.music.load("musique_difficile.mp3")
    pg.mixer.music.set_volume(volume)
    pg.mixer.music.play()
    zone.delete(aff_niv)
    zone.delete(aff_pseudo)
    aff_niv = zone.create_text(250,10, text = "Niveau "+str(nom_diff), font=("Courier", 30), anchor = "nw")
    aff_pseudo = zone.create_text(250,45, text = pseudo, font=("Courier", 20), anchor = "nw")
    

    
def creer_images(): #Crée les images de fond et de la taupe                                                                      
    fond = ImageTk.PhotoImage(Image.open("fondtaupe.png"), master = fenetre)                
    img_fond = zone.create_image(0,0,anchor="nw",image = fond)

    taupe = ImageTk.PhotoImage(Image.open("taupe 2.png"), master = fenetre)
    big_mole = ImageTk.PhotoImage(Image.open("grosse taupe.png"), master = fenetre)
    
    egg = ImageTk.PhotoImage(Image.open("carre vert.png"), master = fenetre)
    img_egg = zone.create_image(10,660,anchor = "nw", image = egg)
    
    return fond, taupe, big_mole, egg, img_egg

def co_trous(): #Crée un dictionnaire avec les coordonées des différents trous                                                                         
    dic_cos={1:(101,390),2:(353,390),3:(605,390),4:(227,457),5:(481,457),6:(101,522),7:(353,522),8:(605,522),9:(227,590),10:(481,590),11:(101,654),12:(353,654),13:(605,654)}
    return dic_cos

def animation(): #Crée l'animation principale du jeu, celle du mouvement de la taupe                                                                         
    global img_taupe, chrono, compteur_click, v_min, v_max
    
    zone.delete(img_taupe)                                                                   
    numero_trou = randint(1,13)

    co_x = dic[numero_trou][0]                                                              
    co_y = dic[numero_trou][1]                                                              
    img_taupe = zone.create_image(co_x,co_y + 10,anchor="sw",image= taupe)                  
    vitesse = randint(v_min,v_max)

    if chrono <= 60 : 
        fenetre.after(vitesse,animation)                                                    
    else :
        print("Game ended !")
        stockage()
        reset()

def stockage(): #Stocke le score et la précision dans un fichier
    global classement, nom_diff
    
    if compteur_click != 0:
        precision = round(score / compteur_click * 100,2)
    else :
        precision = 0

    with open(nom_diff+".txt","a+") as fichier :
            fichier.write(str(score)+","+str(precision)+"%,"+pseudo+"\n")
            fichier.close()

def affichage_score(): #Affiche le score et le nombre de clicks dans la zone de jeu
    global aff_score, aff_compt
    zone.delete(aff_score)
    zone.delete(aff_compt)
    aff_score = zone.create_text(25,75, text = "Score : "+str(score), font = ("System", 30), anchor = "nw")
    aff_compt = zone.create_text(337,75, text = "Nombre de clicks : "+str(compteur_click), font = ("System", 30), anchor = "nw")

def difficulty(): #Donne le nom de la difficulté du niveau
    global nom_diff, v_min
    liste = [600,400,200]
    liste_diff = ["facile","moyen","difficile"] 
    for i in range(len(liste)):
        if liste[i] == v_min :
            nom_diff = liste_diff[i]
        
def affichage_classement(): #Affiche / cache le classement dans la zone de jeu
    global aff_niv,z1,z2,z3,z4,z5,on_off
    on_off *= -1
    if on_off == 1:
        bouton_classement['text'] = "Cacher le classement"
    elif on_off == -1:
        bouton_classement['text'] = "Afficher le classement"
    
    zone.delete(z1)
    zone.delete(z2)
    zone.delete(z3)
    zone.delete(z4)
    zone.delete(z5)
    

    if on_off == 1 :
        with open(nom_diff+".txt","r+") as fichier :
            leaderboard = fichier.readlines()
            fichier.close()

            if leaderboard != "":
                classement = tri(leaderboard)
                if len(classement) < 5:
                    for i in range(5-len(classement)):
                        classement.append("")
                z1 = zone.create_text(25, 120, text="1ere place : "+str(classement[0]), font=("Courier", 15), anchor = "nw")
                z2 = zone.create_text(25, 160, text="2eme place : "+str(classement[1]), font=("Courier", 15), anchor = "nw")
                z3 = zone.create_text(25, 200, text="3eme place : "+str(classement[2]), font=("Courier", 15), anchor = "nw")
                z4 = zone.create_text(25, 240, text="4eme place : "+str(classement[3]), font=("Courier", 15), anchor = "nw")
                z5 = zone.create_text(25, 280, text="5eme place : "+str(classement[4]), font=("Courier", 15), anchor = "nw")

def tri(liste): #Trie le classement dans l'ordre croissant
    lst = [""] * len(liste)
    liste_copy = [""] * len(liste)
    
    for i in range(len(liste)):
        elt = str(liste[i])
        if liste[i][1] == "," :
            lst[i] = ["00"+elt,i]
        elif liste[i][2] == ",":
            lst[i] = ["0"+elt,i]
        else:
            lst[i] = [elt,i] 
    lst.sort(reverse = True)
    
    for j in range(len(lst)):
        liste_copy[j] = liste[lst[j][1]]

    return liste_copy
    
def click_sur_taupe(event): #Crée l'évènement du click sur la taupe pour augmenter le score
    global score, compteur_click 
    x_click = event.x
    y_click = event.y
    x_min, y_max = zone.coords(img_taupe)
    x_max = x_min + 87
    y_min = y_max - 87
    PlaySound("mitrailleuse.wav", SND_ASYNC)

    if chrono != 0 :
        if x_click > x_min and x_click < x_max and y_click > y_min and y_click < y_max :
            score += 1
            PlaySound("death.wav", SND_ASYNC)
        compteur_click += 1
        affichage_score()

def affichage_chrono(): #Affiche le compte à rebours de la partie dans la zone de jeu
    global chrono,aff_chrono
    zone.delete(aff_chrono)
    compt_rebours = 60 - chrono
    if chrono == 61:
        compt_rebours = 0
    aff_chrono = zone.create_text(200,740,text = "Temps restant : " + str(compt_rebours), font = ("System", 30), anchor = "nw")
        
def chronometre(): #Crée un système de chronomètre pendant 60 secondes
    global chrono
    chrono += 1
    affichage_chrono()
    if chrono <= 60 :
        fenetre.after(1000,chronometre)

def reset(): #Remet les variables à 0 à la fin de la partie
    global chrono, score, v_max, v_min, compteur_click, on_off
    if chrono == 61 :
        fin()
        score = 0
        chrono = 0
        v_min = 0
        v_max = 0
        on_off = -1
        compteur_click = 0
        bouton_valider["state"] = 'normal'
        

def fin():
    global score, aff_fin, img_taupe, img_big_mole
    zone.delete(img_taupe)
    img_big_mole = zone.create_image(400,400, anchor = "center", image = big_mole)
    aff_fin = zone.create_text(410,435,font = ('System', 100), anchor = "center", text = score)
    pg.mixer.music.set_volume(0) 

def sound_up(event):
    global volume
    if volume != 1:
        volume += 0.05
        pg.mixer.music.set_volume(volume)

def sound_down(event):
    global volume
    if volume != 0:
        volume -= 0.05
        pg.mixer.music.set_volume(volume)
        
def easter_egg(event):
    x_min,y_min = zone.coords(img_egg)
    x_max = x_min + 20
    y_max = y_min + 20
    x_click = event.x
    y_click = event.y
    if x_click > x_min and x_click < x_max and y_click > y_min and y_click < y_max :
        pg.mixer.music.load("music_egg.mp3")
        pg.mixer.music.play()
    

#Initialisation des variables globales ---------------------------------------
img_taupe = None
aff_compt = None
aff_score = None
aff_niv = None
aff_chrono = None
aff_pseudo = None
aff_fin = None
img_big_mole = None
z1 = None
z2 = None
z3 = None
z4 = None
z5 = None
volume = 0.5

on_off = -1

nom_diff = ""

music = 1
compteur_click = 0
chrono = 0
score = 0
v_max = 0
v_min = 0

#Main ------------------------------------------------------------------------



fenetre = creer_fenetre()
zone, bouton_facile, bouton_moyen, bouton_difficile, bouton_classement, text_pseudo, zone_pseudo, bouton_valider = widgets() 
fond, taupe, big_mole, egg, img_egg = creer_images()

dic = co_trous()

zone.bind("<ButtonPress-1>", click_sur_taupe)
zone.bind("<ButtonPress-3>", easter_egg)
fenetre.bind("<Up>", sound_up)
fenetre.bind("<Down>", sound_down)

fenetre.mainloop()


